module TeamcityHooks
  # @api: @configure
  # TeamcityHooks.configure do |c|
  #   c.config_file
  #   c.endpoint = 'http://teamcity.renewfund.com'
  #   c.username = ''
  #   c.password = ''
  # end

  def configure(&block)
    yield configuration
  end

  module_function :configure

  private
  def configuration
    @configuration ||= Configuration.new
  end

  class Configuration
    attr_accessor :config_file, :endpoint, :username, :password

    def endpoint
      @endpoint || config.endpoint
    end

    def username
      @username || config.username
    end

    def password
      @password || config.password
    end

    def config
      OpenStruct.new(YALM.load_file(@config_file))
    end
  end
end
